% \documentclass[noanswers, nolegalese, 11pt]{examjh}
\documentclass[answers, nolegalese, 11pt]{examjh}
\usepackage{../../../../computingfonts}
\usepackage{../../../../contentmacros}
\usepackage{../../../../grammar}
\usepackage{graphicx}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\pagestyle{empty}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{Questions for Four.II\hfill  From \textit{Theory of Computation}, by Hef{}feron}\vspace{-1ex}
\makebox[\textwidth]{\hbox{}\hrulefill\hbox{}}


\begin{questions}
\question
Using this grammar
\begin{grammar}
  S \produces{} T\trm{b}U

  T \produces{} \trm{a}T \syntaxor \emptystring{}

  U \produces{} \trm{a}U \syntaxor \trm{b}U \syntaxor \emptystring{}  
\end{grammar}
\begin{parts}
\part Give a derivation of \str{aabab}.
\begin{solution}
  \begin{center}
  \begin{tabular}{l}
    S \derives T \trm{b} U
    \derives \trm{a} T \trm{b} U    
    \derives \trm{a} \trm{a} T \trm{b} U    
    \derives \trm{a} \trm{a} \emptystring{} \trm{b} U
       =\trm{a} \trm{a} \trm{b} U    
    \\ \quad 
    \derives \trm{a} \trm{a} \trm{b} \trm{a} U
    \derives \trm{a} \trm{a} \trm{b} \trm{a} \trm{b} U
    \derives \trm{a} \trm{a} \trm{b} \trm{a} \trm{b} \emptystring{}
    =\trm{a} \trm{a} \trm{b} \trm{a} \trm{b}
  \end{tabular}
  \end{center}
\end{solution}

\part Do the same for \str{baab}.
\begin{solution}
\begin{center}
  \begin{tabular}[t]{l}
    S\derives  T \trm{b} U
    \derives \emptystring{} \trm{b} U
      = \trm{b} U    
    \derives \trm{b} \trm{a} U 
    \\ \quad 
    \derives \trm{b} \trm{a} \trm{a} U 
    \derives \trm{b} \trm{a} \trm{a} \trm{b} U 
    \derives  \trm{b} \trm{a} \trm{a} \trm{b} \emptystring{}  
    =  
    \trm{b} \trm{a} \trm{a} \trm{b} 
  \end{tabular}
\end{center}
\end{solution}

\part Show that there is no derivation of \str{aa}.
\begin{solution}
The start symbol expands to something that includes a \trm{b}.
\end{solution}
\end{parts}


\question\ 
  \begin{center}
    \includegraphics{../../../../automata/asy/nfsm/nfsm29.pdf}
  \end{center}
\begin{parts}
\part Show that it accepts \str{011} by producing a suitable sequence
  of $\yields$ relations.
\begin{solution}
    \begin{equation*}
      \sequence{q_0,\str{011}}
      \yields \sequence{q_2,\str{11}}
      \yields \sequence{q_2,\str{1}}
      \yields \sequence{q_2,\emptystring}     
    \end{equation*}  
\end{solution}
% \part What happens if you try this as a first step?
%     \begin{equation*}
%       \sequence{q_0,\str{011}}
%       \yields \sequence{q_1,\str{11}}
%     \end{equation*}  
% \begin{solution}
% Nothing happens.
% There is nothing wrong with this step. 
% It is just an attempt that doesn't lead to the string 
% being accepted.   
\end{solution}
\part Show that the machine accepts \str{00011} by producing a suitable sequence
  of $\yields$ relations.
\begin{solution}
Here is a sequence of steps that ends, with the empty string, in an
accepting state.
\begin{equation*}
\sequence{q_0,\str{00011}}
\yields
\sequence{q_1,\str{0011}}
\yields
\sequence{q_1,\str{011}}
\yields
\sequence{q_1,\str{11}}
\yields
\sequence{q_2,\str{1}}
\yields
\sequence{q_2,\emptystring}
\end{equation*}
\end{solution}

\part Does it accept the empty string?
\begin{solution}
Yes, $q_0$ is accepting.
\end{solution}
\part \str{0}?
  \str{1}?  
\begin{solution}
It accepts \str{0} because it can go through these steps that
end in an accepting state.
\begin{equation*}
  \sequence{q_0,\str{0}}
\yields
\sequence{q_2,\emptystring}
\end{equation*}
It does not accept \str{1} because there is no such sequence of steps.
\end{solution}

\part List five strings of minimal length that it accepts.
\begin{solution}
Here are five:
\emptystring, \str{0}, \str{01}, \str{011}, and \str{0111}.
\end{solution}

\part List five of minimal length that it does not accept.
\begin{solution}
Here are five:
\str{1}, \str{10}, \str{11}, \str{010}, and~\str{110}.
\end{solution}

\part What is the language of this machine?
\begin{solution}
    One description is
    $\lang=\set{\sigma\in\kleenestar{\B}\suchthat
      \text{$\sigma=\emptystring$
        or $\sigma=\str{0}^i\str{1}^j$ for $i\geq 1$ and~$j\geq 0$}}$.
\end{solution}
\end{parts}


\question
This nondeterministic Finite State
machine has $\Sigma=\set{\str{a},\str{b}}$, and includes $\varepsilon$
transitions.
\begin{center}
  \includegraphics{../../../../automata/asy/nfsm/nfsm19.pdf}
\end{center}
\begin{parts}
\part What is the $\varepsilon$ closure of $q_0$?
Of $q_1$?
$q_2$?
\begin{solution}
Here are the $\varepsilon$ closures.
\begin{center}
\begin{tabular}{r|*{3}{c}}
  \tabulartext{state} &$q_0$  &$q_1$  &$q_2$  \\
  \cline{2-4}
  \tabulartext{$\varepsilon$ closure}
                      &$\set{q_0}$ &$\set{q_1,q_2}$  &$\set{q_2}$
\end{tabular}
\end{center}
\end{solution}

\part Does this machine accept the empty string?
\begin{solution}
It does not accept the empty string because the $\varepsilon$~closure
  of $q_0$ does not contain any final states.
\end{solution}
\part Does it accept \str{a}?
  \str{b}?  
\begin{solution}
It accepts both of the one-character strings \str{a} and~\str{b}.
  For instance, on the string~\str{a} the machine can transition 
  from $q_0$ to~$q_1$,
  and then it can make an $\varepsilon$~transition to~$q_2$, which is 
  an accepting state. 
\end{solution}
\item Show that it accepts \str{aab} by producing a suitable sequence
  of $\yields$ relations.
  \begin{solution}
    \begin{equation*}
      \sequence{q_0,\str{aab}}
      \yields \sequence{q_0,\str{ab}}
      \yields \sequence{q_1,\str{b}}
      \yields \sequence{q_2,\str{b}}
      \yields \sequence{q_2,\emptystring}     
    \end{equation*}  
  \end{solution}

\part List five strings of minimal length that it accepts.
\begin{solution}
Five of the shortest strings are: \str{a}, \str{b}, \str{aa}, \str{ab},
  and~\str{aab}.
\end{solution}

\part List five of minimal length that it does not accept.
\begin{solution}
Five that it does not accept are:~the empty string~$\emptystring$,
  \str{ba}, \str{baa}, \str{bab}, and~\str{baaa}.
\end{solution}
\end{parts}


\end{questions}
\end{document}
